From 9ea7e27853c08096090abd5dcc3bb5234afa509c Mon Sep 17 00:00:00 2001
From: Mikhail Shagov <mishaga@users.noreply.github.com>
Date: Fri, 15 Sep 2023 18:44:05 +0100
Subject: [PATCH] fix pydantic version checking (#80)

Co-authored-by: Shagov <shagov@tochka.com>
---
 dirty_equals/_other.py | 9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

diff --git a/dirty_equals/_other.py b/dirty_equals/_other.py
index f2e5fbd..7da1904 100644
--- a/dirty_equals/_other.py
+++ b/dirty_equals/_other.py
@@ -229,7 +229,8 @@ def __init__(
             self.RedisDsn = RedisDsn
             self.parse_obj_as = parse_obj_as
             self.ValidationError = ValidationError
-            self.pydantic_version = version.VERSION
+            self.pydantic_version = tuple(map(int, version.VERSION.split('.')))
+
         except ImportError as e:
             raise ImportError('pydantic is not installed, run `pip install dirty-equals[pydantic]`') from e
         url_type_mappings = {
@@ -264,7 +265,11 @@ def equals(self, other: Any) -> bool:
         except self.ValidationError:
             raise ValueError('Invalid URL')
 
-        equal = parsed == other if self.pydantic_version < '2' else parsed.unicode_string() == other
+        if self.pydantic_version[0] == 1:  # checking major version
+            equal = parsed == other
+        else:
+            equal = parsed.unicode_string() == other
+
         if not self.attribute_checks:
             return equal
 
